program artificial_intelligence;

{$APPTYPE CONSOLE}
{$R+}

const
  maxk = 11;
  maxn = 1100;
  mes: array[0..1] of string = ('CAST SPELL', 'HIT BY SWORD');

var
  cl, best_cl, i, j, k, l, m, n: integer;
  c: array[0..1] of integer;
  mn: array[0..1] of array[1..maxk] of extended;
  cov, cov1, w: array[0..1] of array[1..maxk, 1..maxk] of extended;
  par: array[0..1, 1..maxn, 1..maxk] of integer;
  det, pr: array[0..1] of extended;
  t, alpha: extended;
  p: array[1..maxk] of integer;

begin
  assignfile(input, 'input.txt'); reset(input);
  assignfile(output, 'output.txt'); rewrite(output);

  read(k, m, n);
  for i := 1 to m do
  begin
    read(cl);
    inc(c[cl]);
    for j := 1 to k do read(par[cl, c[cl], j]);
  end;

  for cl := 0 to 1 do
  begin
    for i := 1 to c[cl] do
      for j := 1 to k do mn[cl, j] := mn[cl, j] + par[cl, i, j] / c[cl];

    for i := 1 to c[cl] do
      for j := 1 to k do
        for l := 1 to k do
          cov[cl][j, l] := cov[cl][j, l] + (par[cl, i, j] - mn[cl, j]) * (par[cl, i, l] - mn[cl, l]) / c[cl];

    for i := 1 to k do
      for j := 1 to k do
        cov1[cl][i, j] := cov[cl][i, j];

    for i := 1 to k do w[cl][i, i] := 1;
    for i := 1 to k do 
      for j := i+1 to k do 
      begin
        alpha := cov[cl][j, i] / cov[cl][i, i];
        for l := i to k do cov[cl][j, l] := cov[cl][j, l] - cov[cl][i, l] * alpha;
        for l := 1 to i do w[cl][j, l] := w[cl][j, l] - w[cl][i, l] * alpha;        
      end;

    det[cl] := 1;
    for i := 1 to k do det[cl] := det[cl] * cov[cl][i, i];

    for i := k downto 1 do
    begin
      for j := i + 1 to k do
        for l := 1 to k do w[cl][i, l] := w[cl][i, l] - w[cl][j, l] * cov[cl][i, j];
      for j := 1 to k do w[cl][i, j] := w[cl][i, j] / cov[cl][i, i];
    end;  
  end;

  for i := 1 to n do
  begin
    for j := 1 to k do read(p[j]);
    best_cl := 0;
    for cl := 0 to 1 do
    begin
      t := 0;
      for j := 1 to k do 
        for l := 1 to k do 
          t := t + w[cl][j, l]*(p[j] - mn[cl, j]) * (p[l] - mn[cl, l]);
      pr[cl] := exp(-t/2) / sqrt(det[cl]);
      if pr[cl] > pr[best_cl] then best_cl := cl;
    end;
    writeln(mes[best_cl]);
  end;

  closefile(input); closefile(output);
end.